<script setup lang="ts">
import { onMounted, reactive } from 'vue'
import FormStepper from '@/components/FormStepper.vue'
import { useRouter } from 'vue-router'
import { useMyDataStore } from '@/stores/my-data'
import AppCard from '@/components/ui/AppCard.vue'
import YearbookExamples from '@/components/YearbookExamples.vue'
import ProgramSelector from '@/components/ProgramSelector.vue'
import type { Program } from '@/scripts/api-helper'

const router = useRouter()
const myData = useMyDataStore()

const state = reactive({
  preferredFirstname: '',
  preferredLastname: '',
  preferredProgram: null as Program | null,
  loading: false
})

onMounted(async () => {
  await myData.load()
  state.preferredFirstname = myData.user!.preferred_firstname || myData.user!.official_firstname
  state.preferredLastname = myData.user!.preferred_lastname || myData.user!.official_lastname
  state.preferredProgram = myData.user!.preferred_program || myData.user!.official_program
})

function submit() {
  if (state.preferredProgram == null) {
    return
  }
  state.loading = true
  myData
    .updateIdentity(state.preferredFirstname, state.preferredLastname, state.preferredProgram)
    .then(() => {
      router.push('/form/profile-picture')
    })
    .finally(() => {
      state.loading = false
    })
}
</script>

<template>
  <main>
    <section class="bg-white antialiased dark:bg-gray-900 md:py-8">
      <div class="mx-auto max-w-screen-xl px-4 2xl:px-0">
        <div class="mx-auto max-w-5xl">
          <FormStepper :current-step="1" />

          <hr class="h-px my-3 lg:my-8 bg-gray-200 border-0 dark:bg-gray-700" />

          <div class="grid grid-cols-1 lg:grid-cols-2 gap-5 lg:gap-8">
            <h2 class="text-xl font-semibold text-gray-900 dark:text-white sm:text-2xl">
              {{ $t('formIdentity.title') }}
            </h2>
            <span><!-- spacer --></span>

            <form
              @submit.prevent
              class="w-full rounded-lg border border-gray-200 bg-white p-4 shadow-sm dark:border-gray-700 dark:bg-gray-800 sm:p-6 lg:max-w-xl lg:p-8"
            >
              <div class="mb-6 space-y-3">
                <div class="">
                  <label
                    for="firstname"
                    class="mb-2 block text-sm font-medium text-gray-900 dark:text-white"
                  >
                    {{ $t('formIdentity.labelFirstname') }}
                  </label>
                  <input
                    v-model="state.preferredFirstname"
                    type="text"
                    id="firstname"
                    class="block w-full rounded-lg border border-gray-300 bg-gray-50 p-2.5 text-sm text-gray-900 focus:border-primary-500 focus:ring-primary-500 dark:border-gray-600 dark:bg-gray-700 dark:text-white dark:placeholder:text-gray-400 dark:focus:border-primary-500 dark:focus:ring-primary-500"
                    placeholder="Martin Vetterli"
                    required
                  />
                </div>

                <div class="">
                  <label
                    for="lastname"
                    class="mb-2 block text-sm font-medium text-gray-900 dark:text-white"
                  >
                    {{ $t('formIdentity.labelLastname') }}
                  </label>
                  <input
                    v-model="state.preferredLastname"
                    type="text"
                    id="lastname"
                    class="block w-full rounded-lg border border-gray-300 bg-gray-50 p-2.5 text-sm text-gray-900 focus:border-primary-500 focus:ring-primary-500 dark:border-gray-600 dark:bg-gray-700 dark:text-white dark:placeholder:text-gray-400 dark:focus:border-primary-500 dark:focus:ring-primary-500"
                    placeholder="Green"
                    required
                  />
                </div>

                <ProgramSelector v-model="state.preferredProgram" />
              </div>

              <div class="flex justify-end">
                <AppButton @click="submit" variant="outlined" :loading="state.loading"
                  >{{ $t('ui.next') }}
                </AppButton>
              </div>
            </form>

            <div class="flex flex-col gap-3">
              <AppCard :title="$t('formIdentity.sideInfoTitle')">
                <p class="whitespace-pre-line font-light text-gray-900 dark:text-white">
                  {{ $t('formIdentity.sideInfoDescription') }}
                </p>
              </AppCard>
              <YearbookExamples />
            </div>
          </div>
        </div>
      </div>
    </section>
  </main>
</template>
